#!/usr/bin/env python3

import subprocess
import tempfile
import configparser
import os


#CONFIGURATION_SAVED=1
#ERROR_SAVING_CONFIGURATION=-1
#CUSTOM_DESIGN_ENABLED=2
#CUSTOM_DESIGN_DISABLED=3
#ETC_FILE_DOES_NOT_EXIST=-4

class PanelDesignManager:
	

	def __init__(self):
		
		pass
		
	#def __init__
	
	# ## PRIVATE FUNCTIONS ## #############################################
	
	def _dump_current_panel_conf(self):
		
		p=subprocess.Popen(["dconf dump /"],shell=True,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
		o,e=p.communicate()
				
		if len(o)>5:
			o=o.decode("utf-8")
			
			c=configparser.ConfigParser()
			c.read_string(o)
			c.optionxform=str
			
			keys_to_remove=[]
	
			for key in c.keys():
				if "org/mate/panel/" not in key:
					keys_to_remove.append(key)
				
			for key in keys_to_remove:
				c.remove_section(key)
				
			return c
			
		return None
		
	#def dump_current_panel_conf
	
	
	def _get_desired_dconf(self):

		config=self._dump_current_panel_conf()
		
		# is there no easy way to dump configparser to str???
		
		tmp_file=tempfile.mktemp()
		f=open(tmp_file,"w")
		config.write(f)
		f.close()
		
		f=open(tmp_file,"r")
		lines=f.readlines()
		f.close()
		content="".join(lines)
		
		os.remove(tmp_file)
		
		return content

	#def _get_desired_dconf
	
	# ## END PRIVATE FUNCTIONS ## #########################################
	

	def get_dconf(self):
		
		return self._get_desired_dconf()
	
	#def get_dconf


#class PanelManager

	

